## enblend-enfuse 4.2

=== CMakeLists.txt ===
# This file is part of enblend/enfuse.
# Licence details can be found in the file COPYING.
#
# Copyright(c) 2009-2015, Kornel Benko <Kornel.Benko@berlin.de>
#                  , Ryan Sleevi <ryan+hugin@sleevi.com>
#                  , Harry van der Wolf <hvdwolf@gmail.com>
# Original file from lyx-project, heavily modified
#
cmake_minimum_required(VERSION 2.8)

set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

project(enblend)
IF(NOT MSVC)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel" FORCE)
ENDIF(NOT MSVC)
# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/
# is checked
# For now, reuse the hugin modules directory
#
# Try to find ...
set(CMAKE_MODULE_PATH) # overwrite cache
find_file(CMAKE_MODULE_PATH CMakeModules
  "${CMAKE_SOURCE_DIR}"
  "${CMAKE_SOURCE_DIR}/../hugin"
  "${CMAKE_SOURCE_DIR}/../hugin-trunk"
  "${CMAKE_SOURCE_DIR}/../../hugin/hugin"
  "${CMAKE_SOURCE_DIR}/../../hugin/trunk"
  "$ENV{HOME}/hugin")
message(STATUS "found hugin modules directory in ${CMAKE_MODULE_PATH}")

set(ARCH_TRIPLET)
if(UNIX)
  FIND_PROGRAM(DPKG_ARCHITECTURE_EXECUTABLE dpkg-architecture)
  if(DPKG_ARCHITECTURE_EXECUTABLE)
    EXECUTE_PROCESS(COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
      OUTPUT_VARIABLE ARCH_TRIPLET
      ERROR_VARIABLE ERROR_ARCH_TRIPLET
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()
endif()
if(ARCH_TRIPLET)
  set(SYSTEM_LIB_DIRS /usr/lib /usr/lib/${ARCH_TRIPLET} /usr/local/lib)
else()
  set(SYSTEM_LIB_DIRS /usr/lib /usr/local/lib)
endif()

include(HuginMacros)
include(FindLibraryForCPU)

set(EXECUTABLE_OUTPUT_PATH  ${CMAKE_BINARY_DIR}/bin)

# Regenerate when calling make
set(CMAKE_SUPPRESS_REGENERATION FALSE)
set(VERSION_INFO "CMake Build")

# Try to get the package version from file
set(TOP_SRC_DIR ${CMAKE_SOURCE_DIR})
file(STRINGS "${TOP_SRC_DIR}/VERSION" _version_lines)
foreach(_v_l ${_version_lines})
  if(_v_l MATCHES "^\([0-9]+\)\\.\([0-9]+\)\(.*\)")
    set(ENBLEND_MAJOR_VERSION ${CMAKE_MATCH_1})
    set(ENBLEND_MINOR_VERSION ${CMAKE_MATCH_2})
    set(_tmp ${CMAKE_MATCH_3})
    if(_tmp MATCHES "^\\.\([0-9]+\)\(.*\)")
      set(ENBLEND_PATCH_VERSION ${CMAKE_MATCH_1})
      set(_tmp ${CMAKE_MATCH_2})
    else()
      set(ENBLEND_PATCH_VERSION "0")
    endif()
    set(PACKAGE_VERSION_STRING ${_v_l})
    set(PACKAGE_URL "http://sourceforge.net/projects/enblend/files/enblend-enfuse/enblend-enfuse-${ENBLEND_MAJOR_VERSION}.${ENBLEND_MINOR_VERSION}/")
    break()
  endif()
endforeach(_v_l)

message(STATUS "Extracted enblend version = ${ENBLEND_MAJOR_VERSION}.${ENBLEND_MINOR_VERSION}.${ENBLEND_PATCH_VERSION}")

# For Win32 builds, assume that all of the libraries are located
# one directory above the current CMakeLists directory
IF(WIN32)
  STRING(REGEX REPLACE "(.*)/[^/]+$" "\\1" work "${CMAKE_SOURCE_DIR}")
  # create the cache entry
  SET(SOURCE_BASE_DIR ${work} CACHE FILEPATH "parent dir of hugin source root")

  LIST(APPEND CMAKE_PREFIX_PATH ${SOURCE_BASE_DIR})
ENDIF(WIN32)

# First include so it picks up(our) config.h
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})

SET(library_type STATIC)
set(common_libs)
IF(WIN32)
# we are using static vigra lib on Windows
ADD_DEFINITIONS(-DVIGRA_STATIC_LIB)
ENDIF(WIN32)

# Configurable options
OPTION(ENABLE_OPENMP "OpenMP Support" OFF)
OPTION(ENABLE_TCMALLOC "TCmalloc Support" OFF)
IF(NOT WIN32)
# dynamic loading on windows is supported by own class
OPTION(ENABLE_DLOPEN "Dlopen Support" ON)
ENDIF()
OPTION(DOC "Create Documentation" OFF)

IF(NOT CMAKE_CL_64)
  OPTION(ENABLE_SSE2 "SSE2 Support(Release builds only)" OFF)
ELSE(NOT CMAKE_CL_64)
  SET(ENABLE_SSE2 OFF CACHE INTERNAL "")
ENDIF(NOT CMAKE_CL_64)
IF(NOT WIN32)
  OPTION(ENABLE_DMALLOC "Use the dmalloc debugging package" OFF)
  OPTION(ENABLE_DMALLOC_FUNC_CHECK "Enable dmalloc function checking" OFF)
ELSE(NOT WIN32)
  SET(ENABLE_DMALLOC OFF CACHE INTERNAL "")
  SET(ENABLE_DMALLOC_FUNC_CHECK OFF CACHE INTERNAL "")
ENDIF(NOT WIN32)

# Compiler specific tweaks and optimizations
# Microsoft Visual C++ compiler does not need any addtional switches for C++11
# so check only other compilers
IF (NOT MSVC)
  FIND_PACKAGE(CXX11Compiler)
  IF(NOT CXX11COMPILER_FOUND)
    MESSAGE(FATAL_ERROR "A C++11 compatible compiler is required.")
  ENDIF()
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG}")
ENDIF()

IF(CMAKE_COMPILER_IS_GNUCXX)
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -ffast-math -DNDEBUG -Wall")
  IF(APPLE AND CMAKE_MAJOR_VERSION EQUAL 2 AND CMAKE_MINOR_VERSION LESS 5)
    ## Add needed Compiler and Linker flags for OSX
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -flat_namespace -undefined suppress")
    SET(CMAKE_CXX_FLAGS "{$CMAKE_CXX_FLAGS} -flat_namespace -undefined suppress")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -flat_namespace -undefined suppress")
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -flat_namespace -undefined suppress")
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -flat_namespace -undefined suppress")
  ENDIF(APPLE AND CMAKE_MAJOR_VERSION EQUAL 2 AND CMAKE_MINOR_VERSION LESS 5)
ELSEIF(WIN32)
  IF(MSVC)
    # Quiet some compiler noise
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)
    ADD_DEFINITIONS(-D_CRT_NONSTDC_NO_DEPRECATE)

    # Due to the number of templates and the added overhead in .obj files from 64-bit builds
    # add /bigobj support
    # details: http://msdn.microsoft.com/en-us/library/ms173499.aspx
    IF(CMAKE_CL_64)
      SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /bigobj")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
    ENDIF(CMAKE_CL_64)

    # compile everything for the static C runtime
    FOREACH(TYPE C CXX)
      # makefiles use blank configuration
      FOREACH(CFG "_DEBUG" "_MINSIZEREL" "_RELEASE" "_RELWITHDEBINFO")
        #MESSAGE("Replacing CMAKE_${TYPE}_FLAGS${CFG}: ${CMAKE_${TYPE}_FLAGS${CFG}}")
        SET(NEW_FLAGS "${CMAKE_${TYPE}_FLAGS${CFG}}")
        # fix up static libc flags
        STRING(REPLACE "/MD" "/MT" NEW_FLAGS "${NEW_FLAGS}")
        # *FORCE* to override whats already placed into the cache
        SET(CMAKE_${TYPE}_FLAGS${CFG} "${NEW_FLAGS}" CACHE STRING
          "CMAKE_${TYPE}_FLAGS${CFG} (overwritten to ensure static build)" FORCE)
        #MESSAGE("New       CMAKE_${TYPE}_FLAGS${CFG}: ${CMAKE_${TYPE}_FLAGS${CFG}}")
      ENDFOREACH(CFG)
    ENDFOREACH(TYPE)
    # link only with the static C runtime !! THIS IS A MUST !!
    SET(NEW_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
    # ensure that the flags are not duplicated on subsequent runs
    STRING(REPLACE " /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\" /LTCG /LARGEADDRESSAWARE" "" NEW_FLAGS "${NEW_FLAGS}")
    # note that flag names (NODEFAULTLIB) etc.) are case sensitive
    SET( CMAKE_EXE_LINKER_FLAGS
      "${NEW_FLAGS} /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\" /LTCG /LARGEADDRESSAWARE"
      CACHE STRING "for MSVC" FORCE
      )

    # Maximize speed
    STRING(REPLACE " /O2 " " /Ox /GL " CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
    STRING(REPLACE " /O2 " " /Ox /GL " CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")

    SET(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /GL")
  ENDIF(MSVC)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

# Required Libraries first
FIND_PACKAGE(LCMS2 REQUIRED)
ADD_DEFINITIONS(-DHAVE_LIBLCMS2)
FIND_PACKAGE(TIFF REQUIRED)
FIND_PACKAGE(Perl REQUIRED)
# this one is needed in doc. (Especially the program "convert")
FIND_PACKAGE(GSL REQUIRED)
include_directories(${GSL_INCLUDE_DIR})
ADD_DEFINITIONS(-DHAVE_LIBGSL)
ADD_DEFINITIONS(-DHAVE_LIBGSLCBLAS)
LIST(APPEND common_libs ${LCMS2_LIBRARIES} ${TIFF_LIBRARIES} ${GSL_LIBRARIES})
include_directories(${TIFF_INCLUDE_DIR} ${LCMS2_INCLUDE_DIR})

# Platform specifics required libraries
IF(WIN32)
  SET(Boost_USE_STATIC_LIBS ON)
  # path for getopt library
  INCLUDE_DIRECTORIES(${TOP_SRC_DIR}/src/win32helpers)
ENDIF(WIN32)

# Boost headers are required, but filesystem is optional
if(WIN32)
  IF( NOT Boost_root_suffix )
    SET( Boost_root_suffix _1_51_0 CACHE STRING "suffix of boost root dir." FORCE )
  ENDIF( NOT Boost_root_suffix )
  SET(Boost_USE_STATIC_LIBS ON)
  if (NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "")
    set(BOOST_ROOT $ENV{BOOST_ROOT})
  else(NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "")
    set(BOOST_ROOT ${SOURCE_BASE_DIR}/boost${Boost_root_suffix})
  endif(NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "")
endif()

# Boost headers are required
FIND_PACKAGE(Boost 1.55 REQUIRED)

#check some header and functions
include(ConfigureChecks.cmake)

include_directories(${Boost_INCLUDE_DIR})

# Optional Libraries
FIND_PACKAGE(ZLIB)
FIND_PACKAGE(JPEG)
FIND_PACKAGE(PNG)
FIND_PACKAGE(OpenEXR)
FIND_PACKAGE(Threads)

# VIGRA uses Has* pre-processor definitions for config.h
ADD_DEFINITIONS(-DHasTIFF)
FIND_PACKAGE(VIGRA REQUIRED)
include_directories(${VIGRA_INCLUDE_DIR})
list(APPEND common_libs ${VIGRA_LIBRARIES})

IF(ZLIB_FOUND)
  LIST(APPEND common_libs ${ZLIB_LIBRARIES})
  include_directories(${ZLIB_INCLUDE_DIR})
  ADD_DEFINITIONS(-DHAVE_LIBZ)
ELSEIF(WIN32)
  IF(PNG_FOUND)
    MESSAGE(STATUS "Disabling support for PNG due to lack of zlib")
    SET(PNG_FOUND 0)
  ENDIF(PNG_FOUND)
ENDIF(ZLIB_FOUND)

IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
  list(APPEND common_libs ${JPEG_LIBRARIES})
  include_directories(${JPEG_INCLUDE_DIR})
ELSE(JPEG_FOUND)
  MESSAGE(STATUS "Compiling without support for JPEG files")
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
  list(APPEND common_libs ${PNG_LIBRARIES})
  include_directories(${PNG_INCLUDE_DIR})
ELSE(PNG_FOUND)
  MESSAGE(STATUS "Compiling without support for PNG files")
ENDIF(PNG_FOUND)

IF(OPENEXR_FOUND)
  ADD_DEFINITIONS(-DHasEXR)
  list(APPEND common_libs ${OPENEXR_LIBRARIES})
  include_directories(${OPENEXR_INCLUDE_DIR})
ELSE(OPENEXR_FOUND)
  MESSAGE(STATUS "OpenEXR support disabled")
ENDIF(OPENEXR_FOUND)

# Now that packages are / are not detected, handle config options

IF(ENABLE_OPENMP)
  FIND_PACKAGE(OpenMP REQUIRED)
  add_definitions(${OpenMP_CXX_FLAGS})
ENDIF(ENABLE_OPENMP)

IF(ENABLE_SSE2)
  set_sse_cxx_flags()
ENDIF(ENABLE_SSE2)

IF(ENABLE_DMALLOC)
  ADD_DEFINITIONS(-DDMALLOC)
  IF(ENABLE_DMALLOC_FUNC_CHECK)
    ADD_DEFINITIONS(-DDMALLOC_FUNC_CHECK)
  ENDIF(ENABLE_DMALLOC_FUNC_CHECK)

  IF(CMAKE_USE_PTHREADS_INIT)
    FIND_LIBRARY(dmalloc_LIBRARIES dmallocthcxx)
  ELSE(CMAKE_USE_PTHREADS_INIT)
    FIND_LIBRARY(dmalloc_LIBRARIES dmalloccxx)
  ENDIF(CMAKE_USE_PTHREADS_INIT)

  IF(NOT dmalloc_LIBRARIES)
    MESSAGE(FATAL_ERROR "dmalloc support requested, but was unable to locate dmalloc library")
  ENDIF(NOT dmalloc_LIBRARIES)

  add_definitions("-g")
  LIST(APPEND common_libs ${dmalloc_LIBRARIES})
ENDIF(ENABLE_DMALLOC)

if(ENABLE_TCMALLOC)
  find_package(TCmalloc REQUIRED)
  add_definitions("-DHAVE_TCMALLOC")
  add_definitions("-DHAVE_TCMALLOC_H")
  include_directories(${TCMALLOC_INCLUDE_DIR})
  LIST(APPEND common_libs ${TCMALLOC_LIBRARIES})
endif()

if(ENABLE_DLOPEN)
  find_package(Dlopen REQUIRED)
  list(APPEND common_libs ${DLOPEN_LIBRARIES})
  set(HAVE_DL 1)
endif()

# Try to create config.h
set(ENBLEND_VERSION_ONLY "${PACKAGE_VERSION_STRING}")
set(PACKAGE_STRING "enblend-enfuse ${ENBLEND_VERSION_ONLY}")
set(ENBLEND_VERSION "${PACKAGE_STRING}")
configure_file(config.h.cmake ${CMAKE_BINARY_DIR}/config.h)
add_definitions(-DHAVE_CONFIG_H)

include_directories(${CMAKE_BINARY_DIR})

# check dependencies for build doc
if (PERL_FOUND AND DOC)
    option(INSTALL_PS_DOC "Install documentation in postscript format" ON)
    option(INSTALL_PDF_DOC "Install documentation in pdf format" OFF)
    option(INSTALL_HTML_DOC "Install documentation in html format" OFF)
    if(NOT INSTALL_PS_DOC AND NOT INSTALL_PDF_DOC AND NOT INSTALL_HTML_DOC)

=== src/CMakeLists.txt ===
# This file is part of enblend/enfuse.
# Licence details can be found in the file COPYING.
#
# Copyright (c) 2009-2015, Kornel Benko <Kornel.Benko@berlin.de>
#                   , Ryan Sleevi <ryan+hugin@sleevi.com>
#                   , Harry van der Wolf <hvdwolf@gmail.com>
#

# Get the version-string from ${TOP_SRC_DIR}/VERSION

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/signature.h"
  COMMAND ${PERL_EXECUTABLE} -I"${TOP_SRC_DIR}/src" "${TOP_SRC_DIR}/src/gen_sig"
  "--extra=${ENBLEND_MAJOR_VERSION}.${ENBLEND_MINOR_VERSION}-${ENBLEND_CHANGESET}"
  ">" "${CMAKE_CURRENT_BINARY_DIR}/signature.h"
  DEPENDS "${TOP_SRC_DIR}/src/gen_sig" "${TOP_SRC_DIR}/VERSION"
  )
add_custom_target(signature DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/signature.h")

include_directories(${TOP_SRC_DIR}/src)
set(ENBLEND_SOURCES 
    fillpolygon.hxx functoraccessor.hxx rect2d.hxx stride.hxx 
    anneal.h assemble.h blend.h bounds.h
    common.h enblend.h enblend.cc fixmath.h
    global.h graphcut.h
    maskcommon.h masktypedefs.h mask.h postoptimizer.h
    nearest.h numerictraits.h
    opencl.h opencl.cc opencl_vigra.h
    openmp_def.h openmp_lock.h openmp_vigra.h
    path.h pyramid.h
    alternativepercentage.h alternativepercentage.cc
    error_message.h error_message.cc
    filenameparse.h filenameparse.cc
    filespec.h filespec.cc
    introspection.h introspection.cc
    mersenne.h mersenne.cc
    parameter.h parameter.cc
    self_test.h self_test.cc
    tiff_message.h tiff_message.cc
    timer.h timer.cc
    minimizer.h minimizer.cc
    muopt.h
)
set(ENFUSE_SOURCES 
    functoraccessor.hxx rect2d.hxx stride.hxx
    assemble.h blend.h bounds.h common.h
    exposure_weight_base.h
    exposure_weight.h exposure_weight.cc
    enfuse.h enfuse.cc fixmath.h
    global.h mga.h numerictraits.h
    opencl.h opencl.cc opencl_vigra.h
    opencl_exposure_weight.h opencl_exposure_weight.cc
    openmp_def.h openmp_lock.h openmp_vigra.h
    pyramid.h
    alternativepercentage.h alternativepercentage.cc
    error_message.h error_message.cc
    filenameparse.h filenameparse.cc
    filespec.h filespec.cc
    introspection.h introspection.cc
    mersenne.h mersenne.cc
    parameter.h parameter.cc
    self_test.h self_test.cc
    tiff_message.h tiff_message.cc
    timer.h timer.cc
    minimizer.h minimizer.cc
    muopt.h
)

set(additional_libs)
if (WIN32)
  list(APPEND ENBLEND_SOURCES win32helpers/delayHelper.h)
  list(APPEND ENFUSE_SOURCES win32helpers/delayHelper.h)
  add_subdirectory(win32helpers)
  list(APPEND additional_libs getopt)
endif()

add_subdirectory(layer_selection)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/layer_selection)
list(APPEND additional_libs layer_selection)

add_subdirectory(dynamic_loader)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/dynamic_loader)
add_definitions(${DL_DEFINITION})
list(APPEND additional_libs dynamic_loader)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

message(STATUS "Boost_FOUND = ${Boost_FOUND}")
message(STATUS "OpenMP_CXX_FLAGS = ${OpenMP_CXX_FLAGS}")

add_executable(enblend ${ENBLEND_SOURCES})
add_executable(enfuse ${ENFUSE_SOURCES})

add_dependencies(enblend signature)
add_dependencies(enfuse signature)
target_compile_definitions(enblend PUBLIC "-DENBLEND_SOURCE")
target_compile_definitions(enfuse PUBLIC "-DENFUSE_SOURCE")
if(OpenMP_CXX_FLAGS AND NOT MSVC)
    set_target_properties(enblend PROPERTIES LINK_FLAGS ${OpenMP_CXX_FLAGS})
    set_target_properties(enfuse PROPERTIES LINK_FLAGS ${OpenMP_CXX_FLAGS})
    message(STATUS "Adding PROPERTIES LINK_FLAGS to enblend and enfuse")
endif(OpenMP_CXX_FLAGS AND NOT MSVC)
target_link_libraries(enblend ${common_libs} ${additional_libs})
target_link_libraries(enfuse ${common_libs} ${additional_libs})
install(TARGETS enblend enfuse DESTINATION bin CONFIGURATIONS Release RelWithDebInfo MinSizeRel)

if(NOT WIN32)
    # create enblend.1 and enfuse.1
    if(NOT MANDIR AND NOT $ENV{MANDIR} STREQUAL "")
        set(MANDIR "$ENV{MANDIR}")
    elseif(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
        set(MANDIR "man")
    else(NOT MANDIR AND NOT $ENV{MANDIR} STREQUAL "")
        set(MANDIR "share/man")
    endif()
    
    find_program(HELP2MAN_EXE "help2man")
    if (NOT DOC OR ${HELP2MAN_EXE} MATCHES "-NOTFOUND")
        INSTALL(FILES enblend.1 enfuse.1 DESTINATION ${MANDIR}/man1)
    else()
        project(man)
        add_custom_command(
          OUTPUT "${CMAKE_BINARY_DIR}/src/enblend.1"
          COMMAND "${HELP2MAN_EXE}" "--output=enblend.1" "${CMAKE_BINARY_DIR}/bin/enblend"
          DEPENDS "${CMAKE_BINARY_DIR}/bin/enblend"
          )
        add_custom_command(
          OUTPUT "${CMAKE_BINARY_DIR}/src/enfuse.1"
          COMMAND "${HELP2MAN_EXE}" "--output=enfuse.1" "${CMAKE_BINARY_DIR}/bin/enfuse"
          DEPENDS "${CMAKE_BINARY_DIR}/bin/enfuse"
          )
        add_custom_target(man ALL DEPENDS enblend.1 enfuse.1)
        add_dependencies(man enblend enfuse)
        INSTALL(FILES ${CMAKE_BINARY_DIR}/src/enblend.1 ${CMAKE_BINARY_DIR}/src/enfuse.1 DESTINATION ${MANDIR}/man1)
    endif()
endif()

=== src/win32helpers/CMakeLists.txt ===
if (WIN32)
  add_library(getopt STATIC getopt.c getopt.h)
endif()

=== debian/changelog ===
enblend-enfuse (4.2-8) unstable; urgency=low

  * Upgrade watch file to version 4 standard.
  * Add 45_ftbsf_microtype.diff (setting \usepackage[T1]{fontenc}) and a b-d
    on cm-super to fix FTBFS. Closes: #980666

 -- Andreas Metzler <ametzler@debian.org>  Sat, 23 Jan 2021 18:33:16 +0100

enblend-enfuse (4.2-7) unstable; urgency=low

  * Use dh v13 compat level.
  * 40_fixftbfsboost.diff: Fix FTBFS against boost 1.74 (Thanks, Anton
    Gladky!) Closes: #975081

 -- Andreas Metzler <ametzler@debian.org>  Sat, 21 Nov 2020 07:27:03 +0100

enblend-enfuse (4.2-6) unstable; urgency=medium

  * On mipsel build with -g1 instead of -g to fix FTBFS ("as: out of memory
    allocating [...] bytes [...] Fatal error: can't close enfuse-enfuse.o:
    memory exhausted").

 -- Andreas Metzler <ametzler@debian.org>  Sun, 29 Dec 2019 13:35:31 +0100

enblend-enfuse (4.2-5) unstable; urgency=medium

  * Run "wrap-and-sort --max-line-length=72 --short-indent" and add back
    autodeleted comments.
  * Set Rules-Requires-Root: no.
  * [lintian] Drop trailing empty line in changelog.
  * Use dh 12 compat.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 21 Jul 2019 15:03:39 +0200

enblend-enfuse (4.2-4) unstable; urgency=low

  * Point vcs* to salsa.
  * Upgrade to dh compat 10.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 22 Apr 2018 10:18:11 +0200

enblend-enfuse (4.2-3) unstable; urgency=medium

  * Hotfix FTBFS by adding a b-d on texlive-fonts-extra.
    Closes: #884230

 -- Andreas Metzler <ametzler@debian.org>  Thu, 21 Dec 2017 18:55:44 +0100

enblend-enfuse (4.2-2) unstable; urgency=low

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 29 May 2016 13:42:06 +0200

enblend-enfuse (4.2-1) experimental; urgency=low

  * New upstream version.
    + Use original tarball, drop get-orig-source target,
      debian/patches-repack/ and debian/bin/uscan_repack.sh, update
      debian/watch.
  * Rename build-directory from build-no-mp to build-def.
  * As --enable-image-cache is not supported anymore, there is no reason for
    building twice (with image-cache and with OpenMP). enblend-mp and
    enfuse-mp are therefore not shipped anymore as this functionality is
    available in the binaries without -mp suffix.
  * Update b-d for new LaTeX/hevea based build.
  * info docs are not provided anymore.
  * Ship enfuse' examples for --exposure-weight-function=.
  * Drop unused debian/sed-fix-texi-ids file.
  * Ship html documentation.
  * Add 30_hardcode_enfuse_example_dir.diff to fix the reference to
    --exposure-weight-function examples.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 02 Apr 2016 20:20:28 +0200

enblend-enfuse (4.1.5+dfsg-1) unstable; urgency=medium

  * New upstream version.
    + really fixes gcc-6 build (#811869), drop previously added patches.
  * Build with DEB_BUILD_MAINT_OPTIONS hardening=+all.
  * Use dh.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 26 Mar 2016 16:04:19 +0100

=== debian/control ===
Source: enblend-enfuse
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Sebastian Harl <tokkee@debian.org>,
 Andreas Metzler <ametzler@debian.org>
Build-Depends:
 cm-super,
 debhelper-compat (= 13),
 gnuplot,
 graphviz,
 help2man,
 hevea,
 imagemagick,
 libboost-dev (>= 1.55),
 libgsl-dev,
 libjpeg-dev,
 liblcms2-dev (>= 2.5),
 libopenexr-dev,
 libpng-dev,
 libreadonly-perl,
 librsvg2-bin,
 libtiff-dev,
 libvigraimpex-dev (>= 1.8.0+dfsg-2),
 m4,
 perl,
 pkg-config,
 texlive-extra-utils,
 texlive-font-utils,
 texlive-fonts-extra,
 texlive-latex-base,
 texlive-latex-extra,
 texlive-latex-recommended,
 zlib1g-dev
# texlive-latex-base for pdflatex,
# texlive-latex-extra for bold-extra, enumitem, hyphenat, shorttoc, suffix,
#     xstring
# texlive-latex-recommended for footnote, index, listings, microtype, ragged2e
# texlive-extra-utils for texloganalyser
# texlive-font-utils for repstopdf
# texlive-fonts-extra for cmbcsc10 - #884230
# cm-super for fontenc - #980666:
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: http://enblend.sourceforge.net/
Vcs-Git: https://salsa.debian.org/debian-phototools-team/enblend-enfuse.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/enblend-enfuse

Package: enblend
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: hugin
Enhances: hugin
Description: image blending tool
 Enblend is a tool for compositing images. Given a set of images that overlap
 in some irregular way, Enblend overlays them in such a way that the seam
 between the images is invisible, or at least very difficult to see. It can,
 for example, be used to blend a panorama composed of several images.
 .
 It uses a Burt & Adelson multi-resolution spline. This technique tries to
 make the seams between the input images invisible. The basic idea is that
 image features should be blended across a transition zone proportional in
 size to the spatial frequency of the features. For example, objects like
 trees and windowpanes have rapid changes in color. By blending these
 features in a narrow zone, you will not be able to see the seam because the
 eye already expects to see color changes at the edge of these features.
 Clouds and sky are the opposite. These features have to be blended across a
 wide transition zone because any sudden change in color will be immediately
 noticeable.
 .
 Enblend does not align images for you. Use a tool like Hugin or PanoTools to
 do this. The TIFFs produced by these programs are exactly what Enblend is
 designed to work with.

Package: enfuse
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: hugin
Enhances: hugin
Description: image exposure blending tool
 Enfuse blends differently exposed images of the same scene into a nice output
 image, without producing intermediate HDR images that are then tonemapped to a
 viewable image. This simplified process often works much better and quicker
 than the currently known tonemapping algorithms.
 .
 The exposure blending is done using the Mertens-Kautz-Van Reeth exposure
 fusion algorithm. The basic idea is that pixels in the input images are
 weighted according to qualities such as proper exposure, good contrast, and
 high saturation. These weights determine how much a given pixel will
 contribute to the final image.
 .
 Enfuse does not align images for you. Use a tool like Hugin or PanoTools to do
 this. The TIFFs produced by these programs are exactly what Enfuse is designed
 to work with.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for enblend-enfuse
#
# Written by Sebastian Harl <sh@tokkee.org>.
# Andreas Metzler <ametzler@debian.org>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#used by  debian/patches/20_reproducible_sig.diff
export DEB_TOP_DIR:=$(CURDIR)

include /usr/share/dpkg/architecture.mk

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS := hardening=+all

DEB_CFLAGS_MAINT_APPEND   = -Wall -pipe
DEB_CXXFLAGS_MAINT_APPEND = -Wall -pipe

ifeq ($(DEB_HOST_ARCH),mipsel)
	DEB_CFLAGS_MAINT_APPEND   += -g1
	DEB_CXXFLAGS_MAINT_APPEND += -g1
endif
export DEB_CFLAGS_MAINT_APPEND
export DEB_CXXFLAGS_MAINT_APPEND

CONFARGS := --with-openexr=yes
MYDHAUTOOPTS = --builddirectory=build-def

override_dh_auto_configure:
	dh_auto_configure --verbose \
		$(MYDHAUTOOPTS) -- $(CONFARGS) \
		--enable-openmp

override_dh_auto_build:
	dh_auto_build --verbose $(MYDHAUTOOPTS)
	cd build-def && $(MAKE) pdf

	sed -i -e "s/manual page for enblend.*/combine images using a multiresolution spline/" \
		build-def/src/enblend.1
	sed -i -e "s/manual page for enfuse.*/poor man's HDR/" \
		build-def/src/enfuse.1

override_dh_auto_install:
	dh_auto_install --verbose $(MYDHAUTOOPTS)
	mkdir -p $(CURDIR)/debian/enblend/usr/share/doc/enblend/html \
		$(CURDIR)/debian/enfuse/usr/share/doc/enfuse/html
	cd $(CURDIR)/build-def/doc && \
		grep '<img src="[^>]*\.png' enblend*.html | \
		sed -e 's/.*<img src="\([^"]*\)">.*/\1/' | sort -u | \
		xargs -r cp -v \
		--target-directory=$(CURDIR)/debian/enblend/usr/share/doc/enblend/html/ && \
		grep '<img src="[^>]*\.png' enfuse*.html | \
		sed -e 's/.*<img src="\([^"]*\)">.*/\1/' | sort -u | \
		xargs -r cp -v \
		--target-directory=$(CURDIR)/debian/enfuse/usr/share/doc/enfuse/html/

override_dh_compress:
	dh_compress -X.pdf

override_dh_installdocs:
	dh_installdocs -A -a NEWS AUTHORS

%:
	dh $@ $(MYDHAUTOOPTS)

=== debian/watch ===
version=4

opts=dversionmangle=s/\+dfsg$// \
http://sf.net/enblend/enblend(?:-enfuse)?-([0-9.]+)@ARCHIVE_EXT@ \
	debian

## enblend-enfuse 4.2-8+11.0trisquel0

=== debian/changelog ===
enblend-enfuse (4.2-8+11.0trisquel0) aramo; urgency=medium

  * Build as dependency of hugin.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 10 Apr 2023 20:30:05 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: enblend-enfuse
 Section: graphics
 Priority: optional
-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders:
  Sebastian Harl <tokkee@debian.org>,
  Andreas Metzler <ametzler@debian.org>
